//-------------------------------------------------------------------------------------------------
// Universal KS0108 driver library
// (c) Radosaw Kwiecie, radek@dxp.pl
//-------------------------------------------------------------------------------------------------
#include <stdio.h>

#include "KS0108.h"
#include "font5x8.h"
#include "init.h"
//-------------------------------------------------------------------------------------------------
extern void GLCD_InitializePorts(void);
//-------------------------------------------------------------------------------------------------
unsigned char screen_x = 0, screen_y = 0;
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_Initalize(void)
{
unsigned char i;
GLCD_InitializePorts();
for(i = 0; i < 3; i++)
  GLCD_WriteCommand((DISPLAY_ON_CMD | ON), i);
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_GoTo(unsigned char x, unsigned char y)
{
unsigned char i;
screen_x = x;
screen_y = y;

for(i = 0; i < KS0108_SCREEN_WIDTH/64; i++)
  {
  GLCD_WriteCommand(DISPLAY_SET_Y | 0,i);
  GLCD_WriteCommand(DISPLAY_SET_X | y,i);
  GLCD_WriteCommand(DISPLAY_START_LINE | 0,i);
  }
GLCD_WriteCommand(DISPLAY_SET_Y | (x % 64), (x / 64));
GLCD_WriteCommand(DISPLAY_SET_X | y, (x / 64));
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_ClearScreen(void)
{
unsigned char i, j;
for(j = 0; j < KS0108_SCREEN_HEIGHT/8; j++)
  {
  GLCD_GoTo(0,j);
  for(i = 0; i < KS0108_SCREEN_WIDTH; i++)
    GLCD_WriteData(0x00);
  }
}


void GLCD_ClearChar(unsigned char fontwidth, unsigned char fontheight,unsigned char xpos, unsigned char ypos)
{
unsigned char i, j;
for(j = 0; j < fontheight/8; j++)
  {
  GLCD_GoTo(xpos,ypos+j);
  for(i = 0; i < fontwidth; i++)
    GLCD_WriteData(0x00);
  }
xpos=xpos+18;
for(j = 0; j < fontheight/8; j++)
  {
  GLCD_GoTo(xpos,ypos+j);
  for(i = 0; i < fontwidth; i++)
    GLCD_WriteData(0x00);
  }
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
/*
void GLCD_WriteChar(char charToWrite)
{
int i;
unsigned char done,incre;
charToWrite -= 48;  //32
for(done=0;done<24/8;done++)
{
 GLCD_GoTo(20,(1+done));
for(i = 0; i <16; i++) 
{   
  GLCD_WriteData(GLCD_ReadByteFromROMMemory((char *)(zero+ incre )));
  incre++ ;
} 
    GLCD_WriteData(0x00);
}
} */

void GLCD_WriteChar(char charToWrite, unsigned char fontsize,unsigned char xpos, unsigned char ypos)
{
int i;

if(fontsize==BIG_FONT)
    charToWrite -=48;
else
    charToWrite -=32;



//charToWrite -= 32;  //32
for(i = 0; i <fontsize; i++) 
{
    if(i==16)
    {
     GLCD_GoTo(xpos,ypos+1);
    }
    if(i==32)
    {
     GLCD_GoTo(xpos,ypos+2);  
    } 
  /*  if(i==48)
    {
      GLCD_GoTo(20,4)  ;
    }*/
    if(fontsize == BIG_FONT)
    {
  GLCD_WriteData(GLCD_ReadByteFromROMMemory((char *)(font16x24+ (fontsize* charToWrite) + i)));
    }
    else
    {
  GLCD_WriteData(GLCD_ReadByteFromROMMemory((char *)(font5x8  + (fontsize* charToWrite) + i)));
    }
} 
    GLCD_WriteData(0x00);
} 


/*

void GLCD_WriteChar(char charToWrite,char fontsize)
{
int i;
charToWrite -= 32;  //32
for(i = 0; i <5; i++) 
{
  GLCD_WriteData(GLCD_ReadByteFromROMMemory((char *)(font5x8 + (5* charToWrite) + i)));
  //GLCD_WriteData(GLCD_ReadByteFromROMMemory((char *)(zero + (sizeof(zero)* charToWrite) + i)));
}
} */
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_WriteString(char * stringToWrite, unsigned char fontsize, unsigned char xpos, unsigned char ypos)
{
     GLCD_GoTo(xpos,ypos);
while(*stringToWrite)
{
  GLCD_WriteChar(*stringToWrite++, fontsize,xpos, ypos);
if(fontsize==BIG_FONT)
    {
     xpos= xpos+15; 
     GLCD_GoTo(xpos,ypos);
    }
}    
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_SetPixel(unsigned char x, unsigned char y, unsigned char color)
{
unsigned char tmp;
GLCD_GoTo(x, (y / 8));
tmp = GLCD_ReadData();
GLCD_GoTo(x, (y / 8));
tmp = GLCD_ReadData();
GLCD_GoTo(x, (y / 8));
tmp |= (1 << (y % 8));
GLCD_WriteData(tmp);
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_Bitmap(char * bmp, unsigned char x, unsigned char y, unsigned char dx, unsigned char dy)
{
unsigned char i, j;
for(j = 0; j < dy / 8; j++)
  {
  GLCD_GoTo(x,y + j);
  for(i = 0; i < dx; i++) 
    GLCD_WriteData(GLCD_ReadByteFromROMMemory(bmp++));
  }
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------





