/* Microchip Technology Inc. and its subsidiaries.  You may use this software 
 * and any derivatives exclusively with Microchip products. 
 * 
 * THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS".  NO WARRANTIES, WHETHER 
 * EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED 
 * WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A 
 * PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION 
 * WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION. 
 *
 * IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
 * INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
 * WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS 
 * BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE.  TO THE 
 * FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS 
 * IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF 
 * ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
 *
 * MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE 
 * TERMS. 
 */

/* 
 * File:   
 * Author: 
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef XC_HEADER_TEMPLATE_H
#define	XC_HEADER_TEMPLATE_H

#include <xc.h> // include processor files - each processor file is guarded.  
#include "KS0108.h"

// TODO Insert appropriate #inclzude <>

// TODO Insert C++ class definitions if appropriate
#define BIG_FONT 0x30  // Decimal 48, font 16x24
#define SMALL_FONT 0x05 //Decimal 5, font 5x8
#define cnt1_x 10  // x position where counnter 1 is displayed from
#define cnt1_y 34  // y position where counnter 1 is displayed from
#define cnt2_x 50  // x position where counnter 2 is displayed from
#define cnt2_y 34  // y position where counnter 2 is displayed from
#define cnt3_x 90  // x position where counnter 3 is displayed from
#define cnt3_y 34  // y position where counnter 3 is displayed from
#define RESET_NO 98 // reset the counter when (this nummber + 2 ) is reached


// TODO Insert declarations
char FONT = BIG_FONT; //change this value to SMALL_FONT to get small font for all counters
int counter0,counter1,counter2,counter0_display,counter1_display,counter2_display;
int lcd_update0=1, lcd_update1 =1,lcd_update2=1;
char buf0[5], buf1[5], buf2[5]; // buffer to store ASCII value for integers from counter
int *cnt0,*cnt1,*cnt2; // pointerto main counters

void monitor_sol();
void init_board(void);

// TODO Insert declarations or function prototypes (right here) to leverage 
// live documentation

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */

    // TODO If C++ is being used, regular C code needs function names to have C 
    // linkage so the functions can be used by the c code. 

#ifdef	__cplusplus
}
#endif /* __cplusplus */

#endif	/* XC_HEADER_TEMPLATE_H */

